#include <acknex.h>
#include <default.c>
#include "space_game_particle.c"
#include "space_physic.c"

var test;
ENTITY* my_sky;
ENTITY* sun_ent;
ENTITY* ship;
var cam_dist = 50;
SPACEOBJ shipo;
function func_cam_dist()
{
	while(1)
	{
		if(key_p)cam_dist -= 1*time_step;
		if(key_o)cam_dist += 1*time_step;
		wait(1);
	}
}
action star()
{
	vec_set(me.x,vector(10000,0,0));
	vec_rotate(me.x,vector(integer(random(360)),integer(random(360)),0));
	me.ambient = 100;
	set(me,PASSABLE);
	while(1)
	{
		VECTOR tempv;
		vec_diff(tempv,camera.x,me.x);
		vec_to_angle(me.pan,tempv);
		wait(1);
	}
}
action sun()
{
	me.scale_x = 10;
	me.scale_y = 10;
	me.scale_z = 10;
	me.lightrange = 1500;
	me.ambient = 50;
	vec_set(me.blue,vector(255,255,200));
	reset(my,DYNAMIC);
	set(my,POLYGON);
	c_setminmax(me);
	planets[0].ent = me;
	planets[0].mass = 1000000;
	vec_set(planets[0].pos,me.x);
}

function span_partikel(ENTITY* me)
{
	VECTOR t1;
	VECTOR t2;
	VECTOR t3;
	VECTOR tv;	
		vec_for_vertex(t1,me,161);
		vec_for_vertex(t2,me,162);
		vec_for_vertex(t3,me,163);
		vec_set(tv,vector(0,random(1),random(1)));
		vec_rotate(tv,me.pan);
		vec_inverse (tv);
		effect(turbo_particle,1,t1,nullvector);
		effect(turbo_particle,1,t2,nullvector);
		effect(turbo_particle,1,t3,nullvector);
}
function stear(ENTITY* me)
{
	SetMass(shipo,1000);
	UpdateForce(shipo);
	UpdateMovement(shipo);
	while(1)
	{
		VECTOR temp;
		if(key_space)
		{
			if(!key_shiftl)
			{
			
			VECTOR t;
			vec_set(t,vector(5,0,0));
			vec_rotate(t,me.pan);
			AddLinearForce(shipo,nullvector,t);
			}
			else
			AddLinearForce(shipo,vector(5,0,0),nullvector);
			span_partikel(me);
		}
		if(key_b)
		{
			SetMovement(shipo,nullvector,nullvector);
		}
		if(key_v)
		{
			SetLinearForce(shipo,nullvector,nullvector);
		}
		if(key_w)AddRotation(shipo,vector(0,0.05,0));	//c_rotate(me,vector(0,5*time_step,0),USE_AXISR|IGNORE_PASSENTS|IGNORE_PASSABLE);
		if(key_s)AddRotation(shipo,vector(0,-0.05,0));	//c_rotate(me,vector(0,-5*time_step,0),USE_AXISR|IGNORE_PASSENTS|IGNORE_PASSABLE);
		if(key_a)AddRotation(shipo,vector(0.05,0,0));	//c_rotate(me,vector(5*time_step,0,0),USE_AXISR|IGNORE_PASSENTS|IGNORE_PASSABLE);
		if(key_d)AddRotation(shipo,vector(-0.05,0,0));	//c_rotate(me,vector(-5*time_step,0,0),USE_AXISR|IGNORE_PASSENTS|IGNORE_PASSABLE);
		if(key_n)SetRotation(shipo,nullvector);
		vec_set(temp,vector(-cam_dist,0,1));
		vec_rotate(temp,me.pan);
		vec_add(temp,me.x);
		vec_set(camera.x,temp);
		vec_set(camera.pan,me.pan);
		wait(1);
	}
}


action ship()
{
	wait(5);
	me.scale_x = 0.1;
	me.scale_y = 0.1;
	me.scale_z = 0.1;
	c_setminmax(me);
	CreateSpaceObject(me,shipo);
	stear(me);
}
function span_stars()
{
	var stars;
	for (stars=0;stars<500;stars++)
	{
	ent_create("star.bmp",vector(0,0,0),star);
//	wait(1);
	}
}
function main()
{
	video_mode = 9;
	level_load("");
	vec_set(sky_color,vector(1,0,0));
	span_stars();
	wait(-1);
	sun_ent = ent_create("sun.mdl",nullvector,sun);
	ship = ent_create("spaceship4.mdl",vector(1000,0,0),ship);
}