

// a struct for spaceobjects like spaceships which can move
typedef struct {
	ENTITY* ent;
	var mass;
	VECTOR movlocal;
	VECTOR movglobal;
	VECTOR rotlocal;
	VECTOR forlocal;
	VECTOR forglobal;
}SPACEOBJ;


// a struct for the planets will be used later for gravity and aren't affected by the physic
typedef struct {
	ENTITY* ent;
	VECTOR pos;
	var exists;
	var mass;
}PLANET;
// enable a list with planets for calculating gravitation impact to spaceobjects


PLANET planets[20];//={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

// gravitationsconstant G 
var Gravitattionskonstante = 100;//6.67428 * pow(10,-11); 

// the formular for calculating the gravitation between one planet and one spaceobject: g=G*M*m/(r)

//hope that the most functionnames are self explaining

function CreateSpaceObject(ENTITY* me,SPACEOBJ* temp)
{
	temp.ent = me;
}
function AddMovement(SPACEOBJ* temp, VECTOR* local,VECTOR* global)
{
	vec_add(temp.movlocal,local);
	vec_add(temp.movglobal,global);
}

function SetMovement(SPACEOBJ* temp, VECTOR* local,VECTOR* global)
{
	vec_set(temp.movlocal,local);
	vec_set(temp.movglobal,global);
}
function AddRotation(SPACEOBJ* temp, VECTOR* local)
{
	vec_add(temp.rotlocal,local);
}
function SetRotation(SPACEOBJ* temp, VECTOR* local)
{
	vec_set(temp.rotlocal,local);
}
function AddLinearForce(SPACEOBJ* temp, VECTOR* local,VECTOR* global)
{
	vec_add(temp.forlocal,local);
	vec_add(temp.forglobal,global);
}
function SetLinearForce(SPACEOBJ* temp, VECTOR* local,VECTOR* global)
{
	vec_set(temp.forlocal,local);
	vec_set(temp.forglobal,global);
}

// not tested
function ImpulseForce(SPACEOBJ* temp, VECTOR* local,VECTOR* global)
{
	VECTOR* localacceleration = vector(local.x/temp.mass,local.y/temp.mass,local.z/temp.mass);
	VECTOR* globalacceleration = vector(global.x/temp.mass,global.y/temp.mass,global.z/temp.mass);
	AddMovement(temp,vector(localacceleration.x*time_step,localacceleration.y*time_step,localacceleration.z*time_step),vector(globalacceleration.x*time_step,globalacceleration.y*time_step,globalacceleration.z*time_step));
}
function SetMass(SPACEOBJ* temp,mass)
{
	temp.mass=mass;
}
function SetMass(SPACEOBJ* temp,mass)
{
	temp.mass=mass;
}

function SetPlanet(ENTITY* me,var* mass,VECTOR* pos)
{
	var i;
	for(i=0;i<20;i++)
	{
		if (!planets[i].ent)
		{
			planets[i].ent=me;
			planets[i].mass = mass;
			vec_set(planets[i].pos,pos);
			break;
		}
	}
}

// simple function makes some calculation easier
function DivQuad(var* variable)
{


	if (variable!=0)
	{
		var g = variable;
		var res = pow(g,2);
		res = 1/res;
		return res;
	}
	else
	{
		return 0;
	}
}

////////////////////////////////
// Placeholder for the calculation of the Gravity between planets and spaceobjects
// (still buggy)
////////////////////////////////

function UpdateGravitation(SPACEOBJ* temp);

////////////////////////////////


function UpdateForce(SPACEOBJ* temp)
{
	me = temp.ent;
	VECTOR localacceleration;
	VECTOR globalacceleration;
	while(1)
	{
		vec_set(localacceleration,temp.forlocal);
		vec_set(globalacceleration,temp.forglobal);
		vec_scale(localacceleration,1/temp.mass);
		vec_scale(globalacceleration,1/temp.mass);
		
		AddMovement(temp,vector(localacceleration.x*time_step,localacceleration.y*time_step,localacceleration.z*time_step),vector(globalacceleration.x*time_step,globalacceleration.y*time_step,globalacceleration.z*time_step));
		wait(1);
	}
}

function UpdateMovement(SPACEOBJ* temp)
{
	me = temp.ent;
	VECTOR local;
	VECTOR global;
	VECTOR rotation;
	while(1)
	{
		vec_set(local,temp.movlocal);
		vec_set(global,temp.movglobal);
		vec_set(rotation,temp.rotlocal);
		vec_scale(local,time_step);
		vec_scale(global,time_step);
		vec_scale(rotation,time_step);
		c_move(me,local,global,GLIDE|IGNORE_PASSENTS|IGNORE_PASSABLE);
		c_rotate(me,rotation,USE_AXISR|IGNORE_PASSENTS|IGNORE_PASSABLE);
		wait(1);
	}	
}

































/*
function UpdateGravitation(SPACEOBJ* temp)
{
	me = temp.ent;

	VECTOR posme;
	vec_set(posme,me.x);

	while(1)
	{
		var a;

		for(a=0;a<20;a++)
		{

			if (planets[a].ent)
			{

				VECTOR diff;
				
//				ENTFERNUNG BERECHNEN (r)
				
				vec_diff(diff,planets[a].pos,temp.ent.x);
				
//				GRAVITATTION BERECHNEN   g=G*M*m/(r)

				vec_set(tdiff,diff);//entfernung
			test3=a;
		test2 = temp.mass;
		test1 = planets[a].mass;
		

				if(planets[a].mass!=0&&temp.mass!=0){
				vec_scale(diff,Gravitattionskonstante);	
				vec_set(diff,vector(DivQuad(tdiff.x),DivQuad(tdiff.y),DivQuad(tdiff.z)));
				
				vec_scale(diff,planets[a].mass);
				vec_scale(diff,temp.mass);
			//	vec_set(diff,vector(Gravitattionskonstante*planets[a].mass*temp.mass*DivQuad(tdiff.x),Gravitattionskonstante*planets[a].mass*temp.mass*DivQuad(tdiff.y),Gravitattionskonstante*planets[a].mass*temp.mass*DivQuad(tdiff.z)));
				}
				else break;
				
//				Kraft in Beschleunigung umrechnen

				vec_set(tforce,diff);//kraft
				
			//	vec_scale(diff,1/temp.mass);//a=F*1/m
				
//				BESCHLEUNIGUNG IN GESCHWINDIGKEIT
			//	vec_set(taccer,diff);//beschleunigung
				
			//	vec_scale(diff,PHYSIK_UPDATE_TIME);//V=a*t
				
			//	vec_set(tspeed,diff);//GEschwindigkeit
				
//		      Bewegung c_move zu weisen

			//	vec_scale(diff,PHYSIK_UPDATE_TIME);//unabhngig von der frame rat machen
				
			//	vec_set(tway,diff);//weg
				
			//	c_move(me,nullvector,diff,GLIDE|IGNORE_PASSENTS|IGNORE_PASSABLE);//bewegen
				
			}
		}
	wait(-PHYSIK_UPDATE_TIME);
	}
}
*/